﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=9.85
@EndOfDesignText@
#Region Shared Files
#CustomBuildAction: folders ready, %WINDIR%\System32\Robocopy.exe,"..\..\Shared Files" "..\Files"
'Ctrl + click to sync files: ide://run?file=%WINDIR%\System32\Robocopy.exe&args=..\..\Shared+Files&args=..\Files&FilesSync=True
#End Region

'Ctrl + click to export as zip: ide://run?File=%B4X%\Zipper.jar&Args=dem.zip

Sub Class_Globals
	Private Root As B4XView
	Private xui As XUI
	
	Private Panel3D As B4XView
	
	Dim P3D As Object3D
	Dim MaxDem As Int = 4
	Dim DBP As Int = 300dip ' distance between vertices
	Dim dem(MaxDem, MaxDem) As Double
End Sub

Public Sub Initialize
'	B4XPages.GetManager.LogEvents = True
	dem(0, 0) = 100.0
	dem(0, 1) = 50.0
	dem(0, 2) = 70.0
	dem(0, 3) = 10.0
	dem(1, 0) = 10.0
	dem(1, 1) = 10.0
	dem(1, 2) = 10.0
	dem(1, 3) = 10.0
	dem(2, 0) = 10.0
	dem(2, 1) = 220.0
	dem(2, 2) = 10.0
	dem(2, 3) = 10.0
	dem(3, 0) = 10.0
	dem(3, 1) = 10.0
	dem(3, 2) = 10.0
	dem(3, 3) = 10.0
End Sub

'This event will be called once, before the page becomes visible.
Private Sub B4XPage_Created (Root1 As B4XView)
	Root = Root1
	Root.LoadLayout("MainPage")
End Sub

Private Sub B4XPage_Appear
	Dim ID As Int = 0
	' DBP - distance between vertices
	
'	' line
'	P3D.Initialize
'	For z=0 To MaxDem-1 ' start from 0
'		For x=1 To MaxDem-1 ' start from 1
'			Dim NewPointList(2) As Point3D_Type
'			Dim xi As Double = (x-1) * DBP
'			Dim yi As Double = dem(z,x-1)
'			Dim zi As Double = z * DBP
'			Dim xf As Double = x * DBP 
'			Dim yf As Double = dem(z,x)
'			Dim zf As Double = z * DBP
'			NewPointList(0)=(P3D.CtP(xi,yi,zi))
'			NewPointList(1)=(P3D.CtP(xf,yf,zf))
'			
'			P3D.AddPolygon(ID,NewPointList,xui.Color_Black,xui.Color_Transparent)
'		Next
'	Next
'	
'	' col
'	For x=0 To MaxDem-1 ' start from 0
'		For z=1 To MaxDem-1 ' start from 1
'			Dim NewPointList(2) As Point3D_Type
'			Dim xi As Double = x * DBP
'			Dim yi As Double = dem(z-1,x)
'			Dim zi As Double = (z-1) * DBP
'			Dim xf As Double = x * DBP
'			Dim yf As Double = dem(z,x)
'			Dim zf As Double = (z) * DBP
'			NewPointList(0)=(P3D.CtP(xi,yi,zi))
'			NewPointList(1)=(P3D.CtP(xf,yf,zf))
'			
'			P3D.AddPolygon(ID,NewPointList,xui.Color_Black,xui.Color_Transparent)
'		Next
'	Next
	
	P3D.Initialize
	For z=1 To MaxDem-1 ' start from 1
		For x=1 To MaxDem-1 ' start from 1
			Dim NewPointList(4) As Point3D_Type
			Dim x0 As Double = (x-1) * DBP
			Dim y0 As Double = dem(z-1,x-1)
			Dim z0 As Double = (z-1) * DBP
			
			Dim x1 As Double = x * DBP
			Dim y1 As Double = dem(z-1,x)
			Dim z1 As Double = (z-1) * DBP
			
			Dim x2 As Double = x * DBP
			Dim y2 As Double = dem(z,x)
			Dim z2 As Double = z * DBP
			
			Dim x3 As Double = (x-1) * DBP
			Dim y3 As Double = dem(z,x-1)
			Dim z3 As Double = z * DBP
			
			
			NewPointList(0)=(P3D.CtP(x0,y0,z0))
			NewPointList(1)=(P3D.CtP(x1,y1,z1))
			NewPointList(2)=(P3D.CtP(x2,y2,z2))
			NewPointList(3)=(P3D.CtP(x3,y3,z3))
			
			P3D.AddPolygon(ID,NewPointList,xui.Color_Black,xui.Color_LightGray)
		Next
	Next
	
	For i = 0 To 360 Step 5
		P3D.Rotate(Null,-i,i,i).RenderToView(Panel3D,Panel3D.Width/2,Panel3D.Height/2,0.2,1)
		Sleep(100)
	Next
End Sub

'You can see the list of page related events in the B4XPagesManager object. The event name is B4XPage.
Private Sub Button1_Click
	Log("OK")
	For i = 0 To 360 Step 5
		P3D.Rotate(Null,i,i,i).RenderToView(Panel3D,Panel3D.Width/2,Panel3D.Height/2,0.2,1)
		Sleep(100)
	Next
End Sub